POJ 3126 Prime Path【素数+bfs】

24 篇文章 0 订阅

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 15812 Accepted: 8925

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source


题意:

给出两个四位的素数a,b,每次只能改动 a 的某一位,最终使其变成 b ,并且途中经过的数字必须都是四位的数字,问最少需要改动多少次,输出相应的结果


题解:

没别的办法,看到最优路径,首先想到bfs,然后打个素数表,暴力无脑枚举,没想到过了竟然....


/*
http://blog.csdn.net/liuke19950717
*/
#include<cstdio>
#include<queue>
#include<cmath>
#include<algorithm>
using namespace std;
const int maxn=10005;
int prime[maxn];
struct node
{
	int num,time;
}; 
int bfs(int x,int y)
{
	node st={x,0};
	queue<node> q;
	q.push(st);
	int vis[maxn]={0};
	vis[x]=1;
	while(!q.empty())
	{
		st=q.front();q.pop();
		if(st.num==y)
		{
			return st.time;
		}
		for(int i=0;i<4;++i)
		{
			int base=pow(10,i);
			for(int j=0;j<10;++j)
			{
				if(i==0&&j==0)
				{
					continue;
				}
				int tnum=st.num-(st.num/base)%10*base+j*base;
				if(tnum>1000&&!vis[tnum]&&!prime[tnum])
				{
					vis[tnum]=1;
					node tp={tnum,st.time+1};
					//printf("%d\t",tnum);
					q.push(tp);
				}
			}
		}
	}
	return -1;
}
int main()
{
	for(int i=2;i<maxn;++i)
	{
		if(!prime[i])
		{
			for(int j=2*i;j<maxn;j+=i)
			{
				prime[j]=1;
			}
		}
	}
	//freopen("shuju.txt","r",stdin);
	int t;
	scanf("%d",&t);
	while(t--)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		int ans=bfs(x,y);
		if(ans!=-1)
		{
			printf("%d\n",bfs(x,y));
		}
		else
		{
			printf("Impossible\n");
		}
	}
	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值